/* ktest.c -
 * misc kims testing stuff 
 * by Shaggy
 */



uu_putbyte(byte)
	int byte;
{
	byte &= 0x3f;
	if(!byte)
		putchar(0x60);
	else
		putchar(0x20+byte);
}

		
uuencode(name, buf, bytes)
	char *name;
	unsigned char *buf;
	int bytes;
{
int n;
long d;
	puts("begin 644 ");
	puts(name);
	puts("\r\n");
	while(bytes) {
		n = bytes;
		if (n > 45)
			n = 45;
		uu_putbyte(n);
		bytes -= n;
		while(n > 0) {
			d = (buf[0] << 16) | (buf[1] << 8) | (buf[2]);
			buf += 3;
			uu_putbyte(d >> 18);
			uu_putbyte(d >> 12);
			uu_putbyte(d >> 6);
			uu_putbyte(d);
			n -= 3;
		}
		puts("\r\n");
	}
	puts("`\r\nend\r\n");
}


main()
{
char ch;
long *rom;
int len;
int i;
int x;
char buf[80];
	smem_init();
	serial_init();
	asm("mtpr $0,$0x12");
	puts("KREP - Kims Reverse Engineering Project\n");
	puts("(c) 1991  S.S.H. \n\n");
	puts("Enter initialization code: ");
	ch = getch();
	putchar(ch);
	puts("\r\n");
	if (ch == 'g') 
		gtest();
	if (ch == 's') 
		kshell();
	if (ch == 't')
		trek();
	if (ch == 'T')
		trek2();
	if (ch == 'j') {
		while(1) {
			printf("Enter byte: ");
			creadline(buf, 80, '\n');
			i = atoi(buf);
			printf("you entered %x %d\r\n", i, i);
			*(long*)0x200b0044 = i;
		}
	}
	if (ch == 'k') {
		printf("Entering kadb....\r\n");
		kadb();
		printf("done\r\n");
	}
	if (ch == 'j') {
		while(1) {
			printf("Enter byte: ");
			creadline(buf, 80, '\n');
			i = atoi(buf);
			printf("you entered %x %d\r\n", i, i);
			*(long*)0x200b0044 = i;
		}
	}
	if (ch == 'k') {
		printf("Entering kadb....\r\n");
		kadb();
		printf("done\r\n");
	}
	if (ch == 'v') {
		while(1) {
			i++;
			for(x=0; x<(i&0xfff); x++) continue;
			*(long*)0x38000000 = 4;
			for(x=0; x<(i >> 20); x++) continue;
			*(long*)0x38000000 = 0;
			i *= 7931;
		}
	}
	if (ch == 'p') {
		printf("changing status\n");
		*(long*)0x5fe830 = 0x20048a75;
		*(long*)0x5fe838 = 0x20048b46;
		printf("testing...\n");
	}
	if (ch == 'm')
		while(1) mem_script();	
	if (ch != 'y') {
		puts("Very well.  Good night\n");
		printf("printf test:  %d %x %b\r\n\0", 123123, 123123,
123123);
		printf("okay?\r\n");
		printf("x=%x\r\n", *(long*)(0x200b0044));
		return;
	}
	printf("Enter address: ");
	creadline(buf, 80, '\n');
	i = num_of_str(buf);
	rom = (long*)i;
	printf("Enter length (in K): ");
	creadline(buf, 80, '\n');
	i = atoi(buf);
	len = i*1024;
	uuencode("prom", rom, len);
	puts("\r\n\r\nI am done, sir\r\n");
}


mem_script()
{	
char cmd[100];
int adr[100], val[100];
char buf[20];
int i, n;
	i = 0;
	printf("Enter cmd, address, value to write, x to end:\n");
	while(1) {
		creadline( buf, 100, '\n');
		if (buf[0] == 'x')
			break;
		adr[i] = num_of_str(&buf[2]);
		if (buf[0] == 'w') {
			val[i] = num_of_str(&buf[11]);
		} 
		cmd[i] = buf[0];
		i++;
	}
	n = i;
	for(i = 0;  i < n;  i++) {
		if (cmd[i] == 'w')
			*(long*)adr[i] = val[i];
		val[i] = *(long*)adr[i];
	}
	printf("Results:\n");
	for(i = 0;  i < n;  i++) {
		printf("%8x: %8x\n", adr[i], val[i]);
	}
}



gtest()
{
char buf[512];
char buf2[512];
int x,y,dx,dy;
int i;
int xp[100];
int yp[100];
int z;
int d,n;
	creadline(buf,100,'\n');
	d = atoi(buf);
	for(x=0; x<512; x++) {
		buf[x] = 0xff;
		buf2[x] = 0x0;
	}
	x = 100000; y = 100000;
	dx = 800; dy = 0;
        z = 0;
	for(i=0; i<100; i++) {
		xp[i] = 768;
		yp[i] = 500;
	}
	while(1) {
		gput(buf2,xp[z],yp[z],16,16,16,16);
		for(n=0; n<d; n++) 
			continue;
		gput(buf2,xp[z],yp[z],16,16,16,16);
		for(n=0; n<d; n++) 
			continue;
		xp[z] = (x/1000) & ~15;	
		yp[z] = (y/1000);
		gput(buf,xp[z],yp[z],16,16,16,16);
		for(n=0; n<d; n++) 
			continue;
		if (z++ >= 100)
			z = 0;
		x += dx;
		y += dy;
		if (x > 1536000) {
			x = 1536000;
			dx = -dx/2;
		}
		if (y > 1100000) {
			y = 1100000;
			dy = -dy;
		}
		if (x < 0) {
			x = 0;
			dx = -dx*2;
		}
		if (y < 0) {
			y = 0;
			dy = -dy;
		}	
		if (dy > 0 && dy < 5)
			dy = 800;
		dy = dy + 50 + (i % 12) - ((i/10) % 12);	
		dx = dx + ((i/100) % 12) - ((i/1000) % 12);
		i *= 73;
		if (i < 0)
			i = -i*17;
	}
}
