
#include <math.h>


static int WID = 1536;
static int HGT = 1152;


trek()
{
char *buf;
short *b;
register int i;
register int x;
int n;
	buf = (char*)malloc(WID*HGT/8);
	b = (short*)malloc(WID*HGT/8);
	gput(buf,0,0,WID,HGT,WID,HGT,b);
	x = 0;
	while(1) {
		bzero(buf, HGT*WID/8);
		for(i=x; i<HGT; i += 7) {
			line(buf,0,i,i,HGT-1);
		}
		x += 5;
		if (x > HGT) x = 0;
		gput(buf,0,0,WID,HGT,WID,HGT,b);
		n = 1;
/*
		for(i=1; i<WID*HGT/8; i++) {
			if (b[i] == b[i-1])
				n++;
			else {
				printf("%d:%d ", b[i-1], n);
				n = 1;
			}
		}
*/
	}
}


line(buf, x1, y1, x2, y2)
	unsigned char *buf;
	int x1,y1,x2,y2;
{
register int dx,dy;
register int halfx,halfy;
register int yinc,xinc;
register unsigned char *adr;
register unsigned char mask;
register int i;
unsigned char imask;
int count;
	dx = (x2-x1);
	dy = (y2-y1); 
	if (dy > 0)
		yinc = WID/8;
	else {
		yinc = -WID/8;
		dy = -dy;
	}
	if (dx > 0) {
		xinc = 1;
		imask = 0x01;
	} else {
		xinc = -1;
		dx = -dx;
		imask = 0x80;
	}
	adr = buf + (y1*WID/8)+(x1/8);
	mask = 0x01 << (x1 & 0x7);
	if (dx < dy) {
		halfy = dy >> 1;
		i = 0;
		count = dy+1;
		while(count--) {
			*adr |= mask; 
			adr += yinc;
			if ((i += dx) > halfy) {
				i -= dy;
				if (!(mask <<= xinc)) {
					adr += xinc;
					mask = imask;	
				}
			} 
		}
	} else {
		halfx = dx >> 1;
		i = 0;
		count = dx+1;
		while(count--) {
			*adr |= mask; 
			if (!(mask <<= xinc)) {
				adr += xinc;
				mask = imask;	
			}
			if ((i += dy) > halfx) {
				i -= dx;
				adr += yinc;
			} 
		}
	}
}

putpixel(buf, x, y)
	unsigned char *buf;
	int x, y;
{
	buf[(y*WID/8)+(x/8)] |= (0x01 << (x & 0x7));
}




static double trek_pdat[] = {
	0.1, -0.1, 0.1, 0.1, 0.1, 0.1, -0.1, 0.1, 0.1, -0.1, -0.1, 0.1,
	0.1, -0.1, -1.0, -0.1, -0.1, -1.0, -0.1, 0.1, -0.9, 0.1, 0.1, -0.9,
	-0.08, -0.1, -0.5, -0.08, -0.1, -0.4, -0.5, -0.8, -1.0, -0.5, -0.8,
	-0.8, 0.08, -0.1, -0.5, 0.08, -0.1, -0.4, 0.5, -0.8, -1.0, 0.5,
	-0.8, -0.8,	
	-0.45,-0.8,-0.3,-0.45,-1.0,-0.25,-0.55,-1.0,-0.25,-0.55,-0.8,-0.3,
	-0.45,-0.8,-1.4,-0.55,-0.8,-1.4,-0.55,-1.0,-1.5,-0.45,-1.0,-1.5,
	0.45,-0.8,-0.3,0.45,-1.0,-0.25,0.55,-1.0,-0.25,0.55,-0.8,-0.3,0.45,
	-0.8,-1.4,0.55,-0.8,-1.4,0.55,-1.0,-1.5,0.45,-1.0,-1.5,
	0.0,-0.1,0.1,0.0,-0.2,0.1,0.0,-0.45,0.4,0.0,-0.5,-0.1,0.0,-0.1,-0.4,
	0.4,-0.5,-0.1,0.8,-0.5,0.3,0.8,-0.5,1.1,0.4,-0.5,1.5,-0.4,-0.5,1.5,
	-0.8,-0.5,1.1,-0.8,-0.5,0.3,-0.4,-0.5,-0.1,
	0.0,-0.5,0.4,0.0,-0.5,1.0,0.3,-0.5,0.7,-0.3,-0.5,0.7,0.0,-0.6,0.7,
	0.0,-0.45,0.7
};

static short trek_sdat[] = {
	4,1,2,3,4,6,5,8,2,-1,8,7,3,-1,6,7,-1,5,1,-1,
	9,10,12,11,9,-1,13,14,16,15,13,-1,
	20,17,18,19,20,22,21,24,18,-1,24,23,19,-1,22,23,-1,21,17,-1,
	28,25,26,27,28,30,29,32,26,-1,32,31,27,-1,30,31,-1,29,25,-1,
	33,34,35,36,37,33,-1,
	38,39,40,41,42,43,44,45,38,-1,
	46,50,47,51,46,-1,48,50,49,51,48,-1,
};


static double csh_pdat[] = {
-1.0,-0.5,0.0,		/* letter c front dimension */
-1.0,0.5,0.0,
-0.4,0.5,0.0,
-0.4,0.2,0.0,
-0.7,0.2,0.0,
-0.7,-0.2,0.0,
-0.4,-0.2,0.0,
-0.4,-0.5,0.0,
-0.3,-0.5,0.0,		/* letter s front dimension */
-0.3,-0.2,0.0,
0.0,-0.2,0.0,
0.0,-0.1,0.0,
-0.3,-0.1,0.0,
-0.3,0.5,0.0,
0.3,0.5,0.0,
0.3,0.2,0.0,
0.0,0.2,0.0,
0.0,0.1,0.0,
0.3,0.1,0.0,
0.3,-0.5,0.0,
0.4,-0.5,0.0,		/* letter h front dimensions */
0.4,0.5,0.0,
0.6,0.5,0.0,
0.6,0.1,0.0,
0.8,0.1,0.0,
0.8,0.5,0.0,
1.0,0.5,0.0,
1.0,-0.5,0.0,
0.8,-0.5,0.0,
0.8,-0.1,0.0,
0.6,-0.1,0.0,
0.6,-0.5,0.0,
-1.0,-0.5,-0.5,		/* letter c front dimension */
-1.0,0.5,-0.5,
-0.4,0.5,-0.5,
-0.4,0.2,-0.5,
-0.7,0.2,-0.5,
-0.7,-0.2,-0.5,
-0.4,-0.2,-0.5,
-0.4,-0.5,-0.5,
-0.3,-0.5,-0.5,		/* letter s front dimension */
-0.3,-0.2,-0.5,
0.0,-0.2,-0.5,
0.0,-0.1,-0.5,
-0.3,-0.1,-0.5,
-0.3,0.5,-0.5,
0.3,0.5,-0.5,
0.3,0.2,-0.5,
0.0,0.2,-0.5,
0.0,0.1,-0.5,
0.3,0.1,-0.5,
0.3,-0.5,-0.5,
0.4,-0.5,-0.5,		/* letter h front dimensions */
0.4,0.5,-0.5,
0.6,0.5,-0.5,
0.6,0.1,-0.5,
0.8,0.1,-0.5,
0.8,0.5,-0.5,
1.0,0.5,-0.5,
1.0,-0.5,-0.5,
0.8,-0.5,-0.5,
0.8,-0.1,-0.5,
0.6,-0.1,-0.5,
0.6,-0.5,-0.5,
};

static short csh_sdat[] = {
	1,2,3,4,5,6,7,8,1,-1,
	9,10,11,12,13,14,15,16,17,18,19,20,9,-1,
	21,22,23,24,25,26,27,28,29,30,31,32,21,-1,
	33,34,35,36,37,38,39,40,33,-1,
	41,42,43,44,45,46,47,48,49,50,51,52,41,-1,
	53,54,55,56,57,58,59,60,61,62,63,64,53,-1,
	1,33,-1,
	2,34,-1,
	3,35,-1,
	4,36,-1,
	5,37,-1,
	6,38,-1,
	7,39,-1,
	8,40,-1,
	9,41,-1,
	10,42,-1,
	11,43,-1,
	12,44,-1,
	13,45,-1,
	14,46,-1,
	15,47,-1,
	16,48,-1,
	17,49,-1,
	18,50,-1,
	19,51,-1,
	20,52,-1,
	21,53,-1,
	22,54,-1,
	23,55,-1,
	24,56,-1,
	25,57,-1,
	26,58,-1,
	27,59,-1,
	28,60,-1,
	29,61,-1,
	30,62,-1,
	31,63,-1,
	32,64,-1,
};

trek2()
{
char *buf;
register int i;
register int x;
int numv, numc;
int xpnt[100], ypnt[100];
double sx,sy,sz;
double theta,phi,psi;
double xp,yp,zp;
double xv,yv,zv;
int xctr, yctr;
double xpos,ypos;
double cp,sp,ct,st,cs,ss;
int xxx,yyy;
char cbuf[20];
double *pdat;
short *sdat;
	creadline(cbuf,4,'\n');	
	if (cbuf[0] == 'C') {
		pdat = csh_pdat;
		sdat = csh_sdat;
		numv = sizeof(csh_pdat)/sizeof(double)/3;
		numc = sizeof(csh_sdat)/sizeof(short);
	} else {	
		pdat = trek_pdat;
		sdat = trek_sdat;
		numv = sizeof(trek_pdat)/sizeof(double)/3;
		numc = sizeof(trek_sdat)/sizeof(short);
	}
	creadline(cbuf,20,'\n'); xxx = atoi(cbuf);
	creadline(cbuf,20,'\n'); yyy = atoi(cbuf);
	creadline(cbuf,20,'\n'); WID = atoi(cbuf);
	creadline(cbuf,20,'\n'); HGT = atoi(cbuf);
	buf = (char*)malloc(WID*HGT/8);
	sx = 50.0;
	sy = 50.0;
	sz = 50.0;
	xp = 0.0;
	yp = 0.0;
	zp = -200.0;
	xv = 0.0;
	yv = 0.0;
	zv = 200.0;	
	xctr = WID/2;
	yctr = HGT/2;
	theta = 0.0;
	phi = 0.0;
	psi = 0.0;
	gput(buf,xxx,yyy,WID,HGT,WID,HGT);
	x = 0;
	while(1) {
		cp = cos(phi);
		sp = sin(phi);
		ct = cos(theta);
		st = sin(theta);
		cs = cos(phi);
		ss = sin(phi);
		for(i=1; i< (numv+1); i++) {
			calc3d(&xpos, &ypos, 
				pdat[i*3-3]*sx,
				pdat[i*3-2]*sy,
				pdat[i*3-1]*sz,
				xp,yp,zp,
				xv,yv,zv,
				cp,sp,ct,st,cs,ss);
			xpnt[i] = (int)xpos + xctr;
			ypnt[i] = (int)ypos + yctr;
		}
		bzero(buf, HGT*WID/8);
		for(i=1; i<numc; i++) {
			if (sdat[i] != -1 && sdat[i-1] != -1)  {
				clipline(buf,xpnt[sdat[i-1]],ypnt[sdat[i-1]],
					xpnt[sdat[i]],ypnt[sdat[i]]);
			}
		}
		gput(buf,xxx,yyy,WID,HGT,WID,HGT);
		zp += 2.0;
		theta += 0.4;
		phi += 0.20;
		psi += 0.10;
		if (zp > 400.0)
			zp = -400.0;
	}
}



calc3d(xpos, ypos, xp, yp, zp, xc, yc, zc, xv, yv, zv, cp, sp, ct, st, cs, ss)
	double *xpos, *ypos;
	double xp, yp, zp, xc, yc, zc, xv, yv, zv;
	double cp,sp,ct,st,cs,ss;
{
double xct, yct, zsp, xst, yst, zcp, xctsp, ystsp, xt, yt, zt;
	xct = xp*ct;
	yct = yp*ct;
	zsp = zp*sp;
	xst = xp*st;
	yst = yp*st;
	zcp = zp*cp;
	xctsp = xct*sp;
	ystsp = yst*sp;
	xt = xct*cp-yst*cp+zsp+xc;
	yt = xctsp*ss+xst*cs-ystsp*ss+yct*cs-zcp*ss+yc;
	zt = xst*ss-xctsp*cs+ystsp*cs+yct*ss+zcp*cs+zc;
	*xpos = (xt+zt*(xt-xv)/(zv-zt));
	*ypos = (yt+zt*(yt-yv)/(zv-zt));
}


clipline(buf, x1, y1, x2, y2)
	char *buf;
	int x1, y1, x2, y2;
{
int xmin, xmax, ymin, ymax;
double m;
xmin = 0;
ymin = 0;
xmax = HGT-1;
ymax = WID-1;
	if( x1 < xmin && x2 < xmin)
		return;
	if( x1 > xmax && x2 > xmax)
		return;
	if( y1 < ymin && y2 < ymin)
		return;
	if( y1 > ymax && y2 > ymax)
		return;
	if (x2 == x1) {
		if (y1 < ymin)
			y1 = ymin;
		else if (y1 > ymax)
			y1 = ymax;
		if (y2 < ymin)
			y2 = ymin;
		else if (y2 > ymax)
			y2 = ymax;
		line(buf,x1,y1,x2,y2);
		return;
	} 
	if (y2 == y1) {
		if (x1 < xmin)
			x1 = xmin;
		else if (x1 > xmax)
			x1 = xmax;
		if (x2 < xmin)
			x2 = xmin;
		else if (x2 > xmax)
			x2 = xmax;
		line(buf,x1,y1,x2,y2);
		return;
	}
	m = (double)(y2 - y1) / (double)(x2 - x1);
	if( x1 < xmin) {
		y1 = m*(double)(xmin-x1) + y1;
		x1 = xmin;
	} else
	if( x1 > xmax) {
		y1 = m*(double)(xmax-x1) + y1;
		x1 = xmax;
	}
	if( x2 < xmin) {
		y2 = m*(double)(xmin-x2) + y2;
		x2 = xmin;
	} else
	if( x2 > xmax) {
		y2 = m*(double)(xmax-x2) + y2;
		x2 = xmax;
	}
	if( y1 < ymin) {
		x1 = (double)(ymin-y1)/m + x1;
		y1 = ymin;
	} else
	if( y1 > ymax) {
		x1 = (double)(ymax-y1)/m + x1;
		y1 = ymax;
	}
	if( y2 < ymin) {
		x2 = (double)(ymin-y2)/m + x2;
		y2 = ymin;
	} else
	if( y2 > ymax) {
		x2 = (double)(ymax-y2)/m + x2;
		y2 = ymax;
	}
	if (y1 < ymin || y1 > ymax || x1 < xmin || x1 > xmax)
		return;
	if (y2 < ymin || y2 > ymax || x2 < xmin || x2 > xmax)
		return;
	line(buf, x1, y1, x2, y2);
}





