/* error.h
 *   standard error codes:
 */


#ifndef __ERROR_H__
#define __ERROR_H__


#define OK		0
#define FAIL		-1

#define ERR_UNKNOWN	-2	/* unknown error */
#define ERR_NOBUF	-3	/* out of buffers */
#define ERR_NOMEM	-4	/* out of memory */
#define ERR_BUSY	-5	/* device busy */
#define ERR_INVBUF	-6	/* invalid buffer */
#define ERR_INVDEV	-7	/* invalid device */
#define ERR_INVFD	-8	/* invalid file descriptor */
#define ERR_MAXFILES	-9	/* too many files open */
#define ERR_INVIOC	-10	/* unsupported ioctl */

#endif
