/* kims_video.h
 *   definitions for KIMS video controller chips
 */


#define ADDER	0x3c000000

#define ADCT	0x0
#define REQ	0x2
#define INT	0x4
#define STAT	0x6
#define IDD	0xe
#define CMD	0x10
#define MDE	0x12
#define CMD2	0x14
#define IDS	0x18
#define ICS	0x1a
#define PXMN	0x1c
#define PXMX	0x1e
#define PYMN	0x20
#define PYMX	0x22
#define PSE	0x24
#define PYOF	0x26
#define PYSC	0x28
#define PXI	0x2a
#define PYI	0x2c
#define NXI	0x2e
#define NYI	0x30
#define OXI	0x32
#define OYI	0x34
#define CXMN	0x36
#define CXMX	0x38
#define CYMN	0x3a
#define CYMX	0x3c
#define FSDX	0x40
#define SSDY	0x42
#define SXO	0x44
#define SYO	0x46
#define DXO	0x48
#define DYO	0x4a
#define FDX	0x4c
#define FDY	0x4e
#define SDX	0x50
#define SDY	0x52
#define FSC	0x54
#define SSC	0x56
#define S2XO	0x58
#define S2YO	0x5a
#define S2HW	0x5c
#define ERR1	0x5e
#define ERR2	0x60
#define YCT0	0x62
#define YCT1	0x64
#define YCT2	0x66
#define YCT3	0x68
#define XCON	0x6a
#define XL	0x6c
#define YL	0x6e
#define	XCT0	0x70
#define XCT1	0x72
#define XCT2	0x74
#define XCT3	0x76
#define XCT4	0x78
#define XCT5	0x7a
#define XCT6	0x7c
#define SYNP	0x7e

	
#define VID_CSR		0x38000000

#define CUR_CMD		0x3c000400
#define CUR_XPOS	0x3c000402
#define	CUR_YPOS	0x3c000404

