

_start: nop
	nop
	mtpr	$0x400000,$0x00		/* KSP */
	mtpr	$0x380000,$0x04		/* ISP */
	mtpr	$0x1f,$0x12		/* IPL */
	pushl	$0x001f0000
	pushal	chkrel
	rei				/* load new PSL */
chkrel:	movl	$_start, r10
	moval	_start,r8
	moval	_end,r9
	cmpl	r8,r10
	beql	jbegin
/* if code is not at proper address, relocate it */
	brw	_relocate
jbegin:	jmp	begin
	.org	_start+0x100	/* skip 256 bytes */
begin:	mtpr	$0x400000,$0x00		/* KSP */
	mtpr	$0x380000,$0x04		/* ISP */
        mtpr	$0x1f,$0x12		/* IPL */
	pushl	$0x001f0000
	pushal	callmain
	rei				/* load new PSL */
callmain: calls	$0,_main
	halt
	halt
