/* jdep.c
 *
 *  this utility takes a binary file and outputs deposit
 *  commands to be sent to Jake's PDP monitor
 */


#include <stdio.h>
#include <sys/file.h>


int sdelay = 100;

jwrite(fd, str1)
int fd;
char *str1; 
{
char str2[80];
int i;
char ch;
      do {
         for(i=0; i<strlen(str1); i++) {
            write(fd,&str1[i],1);
            read(fd,&str2[i],1);
         }
         write(fd, "\r", 1);
         while(1) {
            while(read(fd, &ch, 1) != 1);
            if (ch == '\r' || ch == '\n')
               break;
            if(ch==0)
               write(0,"(nul)",5);
            if (i<40 && ch)
               str2[i++] = ch;
         }
         str2[i] = '\0';
         do {
            read(fd, &ch, 1);
         } while(ch != '>');
	 if (strcmp(str1, &str2[strlen(str2)-strlen(str1)]) != 0)
            printf("%s\n", str2);
      } while (strcmp(str1, &str2[strlen(str2)-strlen(str1)]) != 0);
}


deposit(fd, adr, lw1, lw2)
int adr;
int lw1;
int lw2;
{
char str1[80];
int i;
char ch;
   sprintf(str1,"D %X %08X", adr, lw1); 
   jwrite(fd,str1);
}


main(argc, argv)
int argc;
char **argv;
{
FILE *f1;
int fd;
int adr = 0;
int ch;
char pname[40];
int i;
char buf[16];
int lw1;
int lw2;
   strcpy(pname, "/dev/ttyj8");
   if (argc < 2) {
      printf("usage: jdep <filename> [d<delay>] [p<port>] [<adr>]\n");
      exit(1);
   }
   if (!(f1 = fopen(argv[1], "r"))) {
      perror(argv[1]);
      exit(1);
   }
   for(i=2; i<argc; i++) {
      if (argv[i][0] == 'd')
         sdelay = atoi(&argv[i][1])*1000;
      else if(argv[i][0] == 'p')
         strcpy(pname, &argv[i][1]);
      else 
         adr = strtol(argv[i],0,16);
   } 
   if ((fd = open(pname, O_RDWR, 0)) < 0) {
      perror("could not open output");
      exit(1);
   }
   write(fd,"\r\r\r\r",4);
   jwrite(fd,"SET DEF QUAD");
   while(!feof(f1)) {
      ch = getc(f1);
      lw1 = ch;
      ch = getc(f1);
      lw1 += ch << 8;
      ch = getc(f1);
      lw1 += ch << 16;
      ch = getc(f1);
      lw1 += ch << 24;
/*
      ch = getc(f1);
      lw2 = ch;
      ch = getc(f1);
      lw2 += ch << 8;
      ch = getc(f1);
      lw2 += ch << 16;
      ch = getc(f1);
      lw2 += ch << 24;
*/
      if (adr%64 == 0) {
          sprintf(buf,"%8d\r", adr);
          write(1,buf,strlen(buf));
      }    
      deposit(fd,adr,lw1);
      adr += 4;
   }
   fclose(f1);
   close(fd);
}
