/*  creadline.c
 *   console read line
 *   Project JakeDev for Computer Science House
 *   December 10th, 1990
 *   by Frank Barrus
 */


#include "types.h"
 

int creadline(buf, siz, eol)
char *buf;
int siz;
char eol;
{
int n = 0;
int max = 0;
char ch;
  while ((ch = getch()) != eol) {
     if (ch==4)  /* end of file */
        return(-1);
     if (ch >= 32 && ch <= 126 && n < siz) {
        putchar(ch);
        *buf++ = ch;
        n++;
        if (n>max) max = n;
     } else
     if ((ch == 8 || ch == 127) && n) {
        putchar('\b');
        buf--;
        n--;
     } 
  }
  while(n++<max)
     putchar(' ');
  n--;
  if(eol == '\n') {
     putchar('\n');
  }
  *buf = '\0';
  return(n);
}

