/* kims_hard.s
 *   various hardware interface routines for the KIMS
 */



/* hardware put sreial character -- currently a
 *	fakeout to the ROMS, until I write it right 
 */

.globl _hard_sputc
_hard_sputc:	.word 0x0c
		movl	4(ap),r2
		movl	*$0x5fe834,r3
		movl	$0x20048ba1,*$0x5fe834
		jsb	*$0x20040058
		movl	$0x20048ba1,*$0x5fe834
		jsb	*$0x20040058
		movl	r3,*$0x5fe834
		movl	4(ap),r0
		ret


/* hardware serial read into buffer  
 */
.globl _hard_sread
_hard_sread:	.word 0x3e
		movl	4(ap),r5	/* buffer address */
		movl	8(ap),r3	/* number of bytes */
		clrl	r4		/* count of characters read */
		movl	$0x200a0000,r2	/* serial I/O address */
sreadloop:	movl	12(ap),r6	/* delay count */
		ashl	$14,r6,r6
sdelayloop:	bbc	$7,(r2),sloop
		movzwl	4(r2),r1
		extzv	$8,$2,r1,r0
		bicw2	$0x300,r1
		cmpb	r0,$2
		bequ	sisok
		cmpb	r0,$3
		bneq	sdelayloop
sisok:		bitw	$0x6000,r1
		bneq	sdelayloop
		movzbl	r1,r1
		brb	sgotit
sloop:		sobgtr	r6,sdelayloop
		brb	sreaddone
sgotit: 	movb	r1,(r5)+	/* store it */
		incl	r4		/* increase character count */
		sobgtr	r3,sreadloop	/* and get some more */
sreaddone:	movl	r4,r0		/* return num chars read */
		ret
	
