/* serial_isr.s
 *   stubs for serial I/O interrupts
 */

.globl _ser_read_isr
.globl _ser_read_svc
.globl _ser_write_isr
.globl _ser_write_svc
.globl _clock_isr
.globl _clock_svc



.align 2
_ser_read_isr:
	movb	$0x80,*$0x2008000f
	pushr	$3
	calls	$0,_ser_read_svc
	popr	$3
	rei


.align 2
_ser_write_isr:
	movb	$0x40,*$0x2008000f
	pushr	$3
	calls	$0,_ser_write_svc
	popr	$3
	rei


.align 2
_clock_isr:
	pushr	$3 
	calls	$0,_clock_svc 
	popr	$3
	rei

