/* scroll.s
 *  routines to scroll the graphics screens on the KIMS
 */


/* Call with: scroll_up(x1,y1,x2,y2,ofs)
 */
.globl _scroll_up
_scroll_up:	.word	0x3e
		movl	$0x38000000,r9
		movl	$0x3c000000,r10
snotrdy2:	bbc	$4,6(r10),snotrdy2
snotrdy:	bbc	$3,6(r10),snotrdy
		clrb	0(r9)
		movb	$0xfc,0(r9)
sloop1:		bbs	$15,0x1200c(r9),sloop1
		movw	4(ap),0x12010(r9)		/* src x */
		addl3	20(ap),8(ap),0x12014(r9)	/* src y */
		movw	12(ap),0x14000(r9)		/* src end x */
		movw	16(ap),0x14004(r9)		/* src end y */
		movw	4(ap),0x12018(r9)		/* dest x */
		movw	8(ap),0x1201c(r9)		/* dest y */
		movw	12(ap),0x14008(r9)		/* dest end x */
		movw	16(ap),0x1400c(r9)		/* dest end y */
		movw	12(ap),0x14010(r9)		/* clip x2 */
		movw	4(ap),0x14014(r9)		/* clip x1 */
		movw	16(ap),0x14018(r9)		/* clip y2 */
		movw	8(ap),0x1401c(r9)		/* clip y1 */
		movw	$0x0000,0x8000(r9)
		movw	$0x0000,0x8004(r9)
		clrb	0(r9)
		movb	$0xfc,0(r9)
		movw	$0x807f,0x1200c(r9)
sloop2:		bbs	$15,0x1200c(r9),sloop2
		movb	$0xf6,0(r9)
		bbs	$3,6(r10),sc_end
		clrw	6(r10)
sloop3:		bbc	$4,6(r10),sloop3
sc_end:		ret


/* Call with: scroll_down(x1,y1,x2,y2,ofs)
 */
.globl _scroll_down
_scroll_down:	.word	0x3e
		movl	$0x38000000,r9
		movl	$0x3c000000,r10
sdnotrdy2:	bbc	$4,6(r10),sdnotrdy2
sdnotrdy:	bbc	$3,6(r10),sdnotrdy
		clrb	0(r9)
		movb	$0xfc,0(r9)
sdloop1:	bbs	$15,0x1200c(r9),sdloop1
		movw	4(ap),0x12010(r9)		/* src x */
		subl3	20(ap),16(ap),0x12014(r9)	/* src y */
		movw	12(ap),0x14000(r9)		/* src end x */
		movw	8(ap),0x14004(r9)		/* src end y */
		movw	4(ap),0x12018(r9)		/* dest x */
		movw	16(ap),0x1201c(r9)		/* dest y */
		movw	12(ap),0x14008(r9)		/* dest end x */
		movw	8(ap),0x1400c(r9)		/* dest end y */
		movw	12(ap),0x14010(r9)		/* clip x2 */
		movw	4(ap),0x14014(r9)		/* clip x1 */
		movw	16(ap),0x14018(r9)		/* clip y2 */
		movw	8(ap),0x1401c(r9)		/* clip y1 */
		movw	$0x0000,0x8000(r9)
		movw	$0x0000,0x8004(r9)
		clrb	0(r9)
		movb	$0xfc,0(r9)
		movw	$0x806d,0x1200c(r9)
sdloop2:	bbs	$15,0x1200c(r9),sdloop2
		movb	$0xf6,0(r9)
		bbs	$3,6(r10),scd_end
		clrw	6(r10)
sdloop3:	bbc	$4,6(r10),sdloop3
scd_end:	ret

