/*  stdio.c
 *    standard I/O routines
 *    author: Frank Barrus
 */


#include "stdio.h"


int stdin, stdout;



/* normal printf() to standard out: */
 

printf(fmt, arg)
	char *fmt;
	int arg;
{
	return(vprintf(fmt,&arg));
}




/* variable-argument list printf(): */

vprintf(fmt, ap)
	char *fmt;
	long *ap;
{
char buf[512];
int len;
	len = vsprintf(buf, fmt, ap);
	if(stdout==0)
		con_write(buf,len);
	else
		serial_write(stdout,buf,len);
	return(len);
}




/* printf() to a string: */

sprintf(s, fmt, arg0)
	char *s;
	char *fmt;
	long arg0;
{
int len;
	len = vsprintf(s, fmt, &arg0);
	return(len);
}




/* put a string to standard out */

puts(s)
	char *s;
{
	if(stdout == 0)
		con_write(s, strlen(s));
	else
		serial_write(stdout, s, strlen(s));
}



/* put a character to standard out */

putchar(ch)
	char ch;
{
	if (stdout == 0)
		con_write(&ch, 1);
	else
		serial_write(stdout, &ch, 1);
}



/* get a character from standard in */

int getch()
{
char ch;
char buf[10];
	while(!serial_read(stdin, &ch, 1)) ;
	return(ch);
}

