/*
**	File:		types.h
**	Purpose:	data type definitions
*/

#ifndef _TYPES_H
#define _TYPES_H

/*
** Simple types.
*/

typedef char		int8;
typedef unsigned char	uint8;
typedef short		int16;
typedef unsigned short	uint16;
typedef long		int32;
typedef unsigned long	uint32;
typedef char		boolean;
typedef long		(*fptr)();
typedef int		status;

#define NULLP(x)	((x*)0L)
#define NULL		0L

#define TRUE	1
#define	FALSE	0


#define mem8(adr)   	(*(unsigned char*)(adr))
#define mem16(adr)  	(*(unsigned short*)(adr))
#define mem32(adr)  	(*(unsigned long*)(adr))

#define bit(x)		(1 << (x))	


#endif _TYPES_H
